 #include <Arduino.h>

 #include <SPI.h>
 #include <Ethernet.h>
 #include <EthernetUdp.h>
 #include <TeensyMAC.h>
 #include <OSCMessage.h>
 // Enter a MAC address and IP address for your controller below.
 // The IP address will be dependent on your local network:
 byte mac[] = {
   0x00, 0xAA, 0xBB, 0xCC, 0xDE, 0x02
 };

 IPAddress ip(192, 168, 1, 204);    //local IP of Arduino/Teensy
 //unsigned int localPort = 8888;      // local port to listen on (not needed for multicast)

 IPAddress ipMulti(239, 200, 200, 200); // ipMidi Multicast address
 unsigned int portMulti = 9977;   // ipMidi Mutlicast port 1


 // buffers for receiving and sending data
 byte packetBuffer[UDP_TX_PACKET_MAX_SIZE];       // buffer to hold incoming packet
 byte sendBuffer1[] = {0x90, 0x14, 0x22};        // MIDI Note On to Multicast address
 byte sendBuffer2[] = {0x80, 0x14, 0x00};        // MIDI Note Off to Multicast address

 // An EthernetUDP instance to let us send and receive packets over UDP
 EthernetUDP Udp;

 void setup() {
   SPI.setSCK(27);
   Ethernet.init(10);
   teensyMAC(mac);
   Ethernet.begin(mac, ip);              // start the Ethernet and UDP:
 //  Udp.beginMulti(ipMulti, portMulti);   // for modified Arduino library
   Udp.beginMulticast(ipMulti, portMulti); // for modified Teensy Ethernet library
   Serial.begin(115200); // higher Baud rate for faster refresh, CHANGE IN SERIAL MONITOR
 }

 void loop() {
   OSCMessage msg("/analog/0");
   msg.add((int32_t)analogRead(0));

   Udp.beginPacket(ipMulti, portMulti);
     msg.send(Udp); // send the bytes to the SLIP stream
   Udp.endPacket(); // mark the end of the OSC Packet
   msg.empty(); // free space occupied by message

   delay(20);
   //UDPsend();   // sending of packets; do not use with UDPreceive because it's including delay()!!
   //UDPreceive();

 }
